#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\..\OneDrive\Pictures\Icons\Programs\PortableApps_v3.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author:         EddCase

 Script Function:
	GUI for mpham's NSP Forwarder tool for 12+

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>
#include <ComboConstants.au3>


;Global Declerations
$hacbrewpac = '"' & @ScriptDir & "\hacbrewpack.exe" & '"'
$titleid = "05000A0000000000" ;16 charaters long
$titlename = "App Name"
$titlepub = "Author"
$nropath = "/switch/application/application.nro"
$corepath = "/retroarch/core/corename.nro"
$rompath = "/retroarch/roms/rom path"
$prodkeys = '"' & @ScriptDir & "\prod.keys" & '"'
$icon = ""
$logo = @ScriptDir & "\control\NintendoLogo.png"
$key = ""
$error = ""

;Check for a backup of the Logo png create a backup if there isn't one
If FileExists (@ScriptDir & "\logo\NintendoLogo.bak") = 0 Then
	FileCopy (@ScriptDir & "\logo\NintendoLogo.png", @ScriptDir & "\logo\NintendoLogo.bak")
Else
	FileCopy (@ScriptDir & "\logo\NintendoLogo.bak", @ScriptDir & "\logo\NintendoLogo.png")
EndIf

;Build Commands for Reference
;hacbrewpack.exe --titleid %id% --titlename %name% --titlepublisher ZZZ --nspdir NSP -k ./prod.keys
;copy icon to control/icon_AmericanEnglish.dat
;add rom and core path to romfs/nextArgv and romfs/nextNroPath

;Create the Gui
#Region ### START Koda GUI section ### Form=
$frmMain = GUICreate("NSP Forwarder Tool for 12+", 609, 437, 192, 124)
$grpMain = GUICtrlCreateGroup("Standard Options", 4, 12, 600, 256)
$inpTitleName = GUICtrlCreateInput("Application Name", 144, 32, 369, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblTitleName = GUICtrlCreateLabel("Application Name", 16, 32, 111, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpAuthor = GUICtrlCreateInput("Author Name", 145, 68, 369, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblAuthor = GUICtrlCreateLabel("Author Name", 17, 68, 122, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpTitleID = GUICtrlCreateInput("Title ID", 145, 108, 369, 24)
GUICtrlSetLimit(-1, 16)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$btnTitleID = GUICtrlCreateButton("Random", 521, 108, 75, 25)
$lblTitleID = GUICtrlCreateLabel("Title ID", 17, 108, 46, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpIcon = GUICtrlCreateInput("Icon Path", 145, 140, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "256 x 256 JPEG")
$btnIcon = GUICtrlCreateButton("Browse", 521, 140, 75, 25)
GUICtrlSetTip(-1, "256 x 256 JPEG")
$lblIcon = GUICtrlCreateLabel("Icon Path", 17, 140, 59, 25, $SS_CENTERIMAGE)
GUICtrlSetTip(-1, "256 x 256 JPEG")
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpLogo = GUICtrlCreateInput("Do not change for default", 145, 172, 369, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "160 x 40 PNG")
$btnLogo = GUICtrlCreateButton("Browse", 521, 172, 75, 25)
GUICtrlSetTip(-1, "160 x 40 PNG")
$lblLogo = GUICtrlCreateLabel("Logo Path", 17, 172, 65, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "160 x 40 PNG")
$inpProd = GUICtrlCreateInput("prod.keys Path", 145, 236, 369, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_DISABLE)
$btnProd = GUICtrlCreateButton("Browse", 521, 236, 75, 25)
GUICtrlSetState(-1, $GUI_DISABLE)
$lblProd = GUICtrlCreateLabel("Prod.keys", 17, 236, 65, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_DISABLE)
$chkProd = GUICtrlCreateCheckbox("Custom prod.key location", 240, 208, 153, 17)
GUICtrlSetTip(-1, "By default it will use prod.keys in the same directory as this gui")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$grpForwarder = GUICtrlCreateGroup("Forwarder Options", 4, 272, 600, 113)
$chkStandard = GUICtrlCreateCheckbox("Standard Nro Forwarder", 160, 288, 137, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$chkRetroArch = GUICtrlCreateCheckbox("RetroArch Rom Forwarder", 336, 288, 145, 17)
$inpNroPath = GUICtrlCreateInput("/switch/application.nro", 145, 320, 361, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblNroPath = GUICtrlCreateLabel("Nro Path", 17, 320, 56, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpRomPath = GUICtrlCreateInput("/roms/rom_name.ext", 145, 355, 361, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$lblRomPath = GUICtrlCreateLabel("Rom Path", 17, 355, 63, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$cmbCore = GUICtrlCreateCombo("Pick a Core", 416, 320, 177, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpCorePath = GUICtrlCreateInput("/retroarch/cores/core.nro", 143, 318, 361, 24)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$lblCorePath = GUICtrlCreateLabel("Core Path", 15, 318, 63, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$btnCreate = GUICtrlCreateButton("Create Forwarder", 4, 390, 600, 40)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

;Create a random title ID
Call ("idrandom")

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $chkProd
			If GUICtrlRead($chkProd) = $GUI_CHECKED Then
                GUICtrlSetState($lblProd, $GUI_ENABLE)
				GUICtrlSetState($inpProd, $GUI_ENABLE)
				GUICtrlSetState($btnProd, $GUI_ENABLE)
            Else
                GUICtrlSetState($lblProd, $GUI_DISABLE)
				GUICtrlSetState($inpProd, $GUI_DISABLE)
				GUICtrlSetState($btnProd, $GUI_DISABLE)
            EndIf
		Case $chkStandard
			If GUICtrlRead($chkStandard) = $GUI_CHECKED Then
				GUICtrlSetState($lblNroPath, $GUI_SHOW)
				GUICtrlSetState($inpNroPath, $GUI_SHOW)
				GUICtrlSetState($inpCorePath, $GUI_HIDE)
				GUICtrlSetState($lblCorePath, $GUI_HIDE)
				GUICtrlSetState($lblRomPath, $GUI_HIDE)
				GUICtrlSetState($inpRomPath, $GUI_HIDE)
				GUICtrlSetState ($chkRetroArch, $GUI_UNCHECKED)
			EndIf
		Case $chkRetroArch
			If GUICtrlRead($chkRetroArch) = $GUI_CHECKED Then
				GUICtrlSetState($lblNroPath, $GUI_HIDE)
				GUICtrlSetState($inpNroPath, $GUI_HIDE)
				GUICtrlSetState($inpCorePath, $GUI_SHOW)
				;GUICtrlSetState($inpCorePath, $GUI_DISABLE)
				GUICtrlSetState($lblCorePath, $GUI_SHOW)
				;GUICtrlSetState($lblCorePath, $GUI_DISABLE)
				GUICtrlSetState($lblRomPath, $GUI_SHOW)
				;GUICtrlSetState($lblRomPath, $GUI_DISABLE)
				GUICtrlSetState($inpRomPath, $GUI_SHOW)
				;GUICtrlSetState($inpRomPath, $GUI_DISABLE)
				GUICtrlSetState ($chkStandard, $GUI_UNCHECKED)
				;MsgBox (0, "Not Yet Ready", "Sorry Not Yet Implemented!")
			EndIF
		Case $btnTitleID
			Call ("idrandom")
		Case $btnIcon
			Call ("iconbrowse")
		Case $btnLogo
			Call ("logobrowse")
		Case $btnCreate
			Call ("errorcheck")
			If $error = 0 Then
				Call ("imagemoves")
				Call ("pathwrites")
				Call ("nspbuild")
			Else
			EndIf
	EndSwitch
WEnd




Func idrandom()
;Random 16 digit number
		$key = ""
		$Key = $Key & Hex(Random() * 10)
		$titleid = "0" & $key
		$titleid = StringTrimRight ( $titleid, 1 )

		GUICtrlSetData ($inpTitleID, $titleid)

EndFunc


Func iconbrowse()
	$icon = FileOpenDialog ("Select your icon file, This needs to be a 256 x 256 jpg or jpeg", @ScriptDir, "Images (*.jpg;*.jpeg)", BitOR($FD_FILEMUSTEXIST, $FD_MULTISELECT))
	If @error Then
		GUICtrlSetData ($inpIcon, "Icon Path")
	Else
		GUICtrlSetData ($inpIcon, $icon)
	EndIf
EndFunc

Func logobrowse()
	$logo = FileOpenDialog ("Select your logo file, This needs to be a 160 x 40 png", @ScriptDir & "\logo", "Images (*.png)", BitOR($FD_FILEMUSTEXIST, $FD_MULTISELECT))
	If @error Then
		GUICtrlSetData ($inpLogo, "Do not change for default")
	Else
		GUICtrlSetData ($inpLogo, $logo)
	EndIf
EndFunc


Func errorcheck()
	;Check The Application Name has changed
	If GUICtrlRead ($inpTitleName) = "Application Name" Then
		Msgbox(0,"Error","You Haven't Changed the Application Name")
		$error = 1
		Return
	Else
		$error = 0
	EndIf

	;Check the Author Name has changed
	If GUICtrlRead ($inpAuthor) = "Author Name" Then
		Msgbox(0,"Error","You Haven't Changed the Author Name")
		$error = 1
		Return
	Else
		$error = 0
	EndIf

	;Check if the Icon Path has changed
	If GUICtrlRead ($inpIcon) = "Icon Path" Then
		Msgbox(0,"Error","You Haven't Choosen an Icon")
		$error = 1
		Return
	Else
		$error = 0
	EndIf
EndFunc

Func imagemoves()
	;Move Images into the corect places
	FileCopy (GUICtrlRead ($inpIcon), @ScriptDir & "\control\icon_AmericanEnglish.dat",1)
	If GUICtrlRead ($inpLogo) = "Do not change for default" Then
		Return
	Else
		FileCopy (GUICtrlRead ($inpLogo), @ScriptDir & "\logo\NintendoLogo.png", 1)
	EndIf
EndFunc

Func pathwrites()
	If GUICtrlRead($chkStandard) = $GUI_CHECKED Then
		FileDelete (@ScriptDir & "\romfs\NextArgv")
		FileWrite (@ScriptDir & "\romfs\nextArgv", "sdmc:" & GUICtrlRead( $inpNroPath))
		FileDelete (@ScriptDir & "\romfs\nextNroPath")
		FileWrite (@ScriptDir & "\romfs\nextNroPath", "sdmc:" & GUICtrlRead( $inpNroPath))
	Else
		FileDelete (@ScriptDir & "\romfs\NextArgv")
		FileWrite (@ScriptDir & "\romfs\nextArgv", "sdmc:" & GUICtrlRead( $inpCorePath) & ' "' & "sdmc:" & GUICtrlRead ($inpRomPath) & '"')
		FileDelete (@ScriptDir & "\romfs\nextNroPath")
		FileWrite (@ScriptDir & "\romfs\nextNroPath", "sdmc:" & GUICtrlRead( $inpCorePath))
	EndIf
EndFunc





Func nspbuild()
;Build Command
		$titleid = GUICtrlRead ($inpTitleID)
		$titlename = GUICtrlRead ($inpTitleName)
		$titlepub = GUICtrlRead ($inpAuthor)
		$build = $hacbrewpac & " --titleid " & '"' & $titleid & '"' & " --titlename " & '"' & $titlename& '"' & " --titlepublisher " & '"' & $titlepub& '"' & " --nspdir NSP" & " -k " & $prodkeys


;Create the batch file
		FileDelete (@ScriptDir & "\GUI_Build.bat")
		FileWrite (@scriptDir & "\GUI_Build.bat", $build & @CRLF)
		FileWrite (@scriptDir & "\GUI_Build.bat", "exit")
		RunWait(@ComSpec & ' /k ' & '"' & @ScriptDir & '\GUI_Build.bat' & '"')
		FileMove (@ScriptDir & "\NSP\" & $titleid & ".nsp", @ScriptDir & "\NSP\" & $titlename & "_" & $titleid & ".nsp")
		ShellExecute ("Explorer.exe",@ScriptDir & "\NSP\",@ScriptDir & "\NSP\")

;Tidy Up

EndFunc