#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author:         EddCase

 Script Function:
	GUI for mpham's NSP Forwarder tool for 12+

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>
#include <ComboConstants.au3>
#include <File.au3>
#include <Array.au3>
#include <GDIPlus.au3>


;Global Declerations
$hacbrewpac = '"' & @ScriptDir & "\hacbrewpack.exe" & '"'
$titleid = "05000A0000000000" ;16 charaters long
$titlename = "App Name"
$titlepub = "Author"
$nropath = "/switch/application/application.nro"
$corepath = "/retroarch/core/corename.nro"
$rompath = "/retroarch/roms/rom path"
$prodkeys = '"' & @ScriptDir & "\prod.keys" & '"'
$icon = ""
$logo = @ScriptDir & "\control\NintendoLogo.png"
$key = ""
$error = ""

;Potential feature, choose default core location from drop down
;Import cores.txt
;_FileReadToArray ( @ScriptDir & "\cores.txt" , ByRef $CoreArray)
;_ArrayDisplay ( Const ByRef $CoreArray)


;Check for a backup of the Logo png create a backup if there isn't one
If FileExists (@ScriptDir & "\logo\NintendoLogo.bak") = 0 Then
	FileCopy (@ScriptDir & "\logo\NintendoLogo.png", @ScriptDir & "\logo\NintendoLogo.bak")
Else
	FileCopy (@ScriptDir & "\logo\NintendoLogo.bak", @ScriptDir & "\logo\NintendoLogo.png")
EndIf

;Build Commands for Reference
;hacbrewpack.exe --titleid %id% --titlename %name% --titlepublisher ZZZ --nspdir NSP -k ./prod.keys
;copy icon to control/icon_AmericanEnglish.dat
;add rom and core path to romfs/nextArgv and romfs/nextNroPath

;Create the Gui
#Region ### START Koda GUI section ### Form=
;$frmMain = GUICreate("NSP Forwarder Tool for 12+", 610, 438, 192, 124)
$frmMain = GUICreate("NSP Forwarder Tool for 12+", 610, 438, -1, -1)
$grpMain = GUICtrlCreateGroup("Standard Options", 4, 12, 600, 256)
$inpTitleName = GUICtrlCreateInput("Application Name", 144, 32, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblTitleName = GUICtrlCreateLabel("Application Name", 16, 32, 111, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpAuthor = GUICtrlCreateInput("Author Name", 144, 65, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblAuthor = GUICtrlCreateLabel("Author Name", 16, 65, 122, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpTitleID = GUICtrlCreateInput("Title ID", 144, 98, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$btnTitleID = GUICtrlCreateButton("Random", 521, 98, 75, 25)
$lblTitleID = GUICtrlCreateLabel("Title ID", 16, 98, 46, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$inpIcon = GUICtrlCreateInput("Icon Path", 144, 131, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "256 x 256 JPEG")
$btnIcon = GUICtrlCreateButton("Browse", 521, 131, 75, 25)
GUICtrlSetTip(-1, "256 x 256 JPEG")
$lblIcon = GUICtrlCreateLabel("Icon Path", 16, 131, 59, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "256 x 256 JPEG")
$inpLogo = GUICtrlCreateInput("Do not change for default", 145, 164, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "160 x 40 PNG")
$btnLogo = GUICtrlCreateButton("Browse", 521, 164, 75, 25)
GUICtrlSetTip(-1, "160 x 40 PNG")
$lblLogo = GUICtrlCreateLabel("Logo Path", 16, 164, 65, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "160 x 40 PNG")
$inpProd = GUICtrlCreateInput("prod.keys Path", 144, 236, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$btnProd = GUICtrlCreateButton("Browse", 521, 236, 75, 25)
$lblProd = GUICtrlCreateLabel("Prod.keys", 16, 236, 65, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$chkProd = GUICtrlCreateCheckbox("Custom prod.key location", 240, 208, 153, 17)
GUICtrlSetTip(-1, "By default it will use prod.keys in the same directory as this gui")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$grpForwarder = GUICtrlCreateGroup("Forwarder Options", 4, 272, 600, 113)
$chkStandard = GUICtrlCreateCheckbox("Standard Nro Forwarder", 160, 288, 137, 17)
$chkRetroArch = GUICtrlCreateCheckbox("RetroArch Rom Forwarder", 336, 288, 145, 17)
$inpNroPath = GUICtrlCreateInput("/switch/application.nro", 144, 318, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$lblNroPath = GUICtrlCreateLabel("Nro Path", 16, 320, 56, 20, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$inpRomPath = GUICtrlCreateInput("/roms/rom_name.ext", 144, 355, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblRomPath = GUICtrlCreateLabel("Rom Path", 16, 355, 63, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$cmbCore = GUICtrlCreateCombo("Pick a Core", 416, 318, 177, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlSetState(-1, $GUI_HIDE)
$inpCorePath = GUICtrlCreateInput("/retroarch/cores/core.nro", 144, 318, 369, 25)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
$lblCorePath = GUICtrlCreateLabel("Core Path", 15, 318, 63, 25, $SS_CENTERIMAGE)
GUICtrlSetFont(-1, 10, 400, 0, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$btnCreate = GUICtrlCreateButton("Create Forwarder", 4, 390, 600, 40)
GUICtrlSetFont(-1, 12, 800, 0, "MS Sans Serif")
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

;Create a random title ID
Call ("idrandom")

;Disable & Hide Menu Components
                GUICtrlSetState($lblProd, $GUI_DISABLE)
				GUICtrlSetState($inpProd, $GUI_DISABLE)
				GUICtrlSetState($btnProd, $GUI_DISABLE)
				GUICtrlSetState($lblNroPath, $GUI_SHOW)
				GUICtrlSetState($inpNroPath, $GUI_SHOW)
				GUICtrlSetState($inpCorePath, $GUI_HIDE)
				GUICtrlSetState($lblCorePath, $GUI_HIDE)
				GUICtrlSetState($lblRomPath, $GUI_HIDE)
				GUICtrlSetState($inpRomPath, $GUI_HIDE)
				GUICtrlSetState ($chkStandard, $GUI_CHECKED)
				GUICtrlSetState ($chkRetroArch, $GUI_UNCHECKED)



While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $chkProd
			Call ("prodkeyscheck")
		Case $btnProd
			Call ("prodbrowse")
		Case $chkStandard
			Call ("standardcheck")
		Case $chkRetroArch
			Call ("retroarchcheck")
		Case $btnTitleID
			Call ("idrandom")
		Case $btnIcon
			Call ("iconbrowse")
		Case $btnLogo
			Call ("logobrowse")
		Case $btnCreate
			Call ("errorcheck")
			If $error = 0 Then
				Call ("imagemoves")
				Call ("pathwrites")
				;Remove the ; before the following line to enable the old GUI_Build.bat method of building the nsp also add ; to the the Call ("newbuild")
				;Call ("nspbuild")
				Call ("newbuild")
				Call ("tidy")
			Else
			EndIf
	EndSwitch
WEnd




Func idrandom()
;Random 16 character HEX starting with 0
		$key = ""
		$Key = $Key & Hex(Random() * 10)
		$titleid = "0" & $key
		$titleid = StringTrimRight ( $titleid, 1 )

		GUICtrlSetData ($inpTitleID, $titleid)

EndFunc

Func prodkeyscheck()
;Enable menu changes when the prod.keys checkbox is clicked
		If GUICtrlRead($chkProd) = $GUI_CHECKED Then
			GUICtrlSetState($lblProd, $GUI_ENABLE)
			GUICtrlSetState($inpProd, $GUI_ENABLE)
			GUICtrlSetState($btnProd, $GUI_ENABLE)
		Else
			GUICtrlSetState($lblProd, $GUI_DISABLE)
			GUICtrlSetState($inpProd, $GUI_DISABLE)
			GUICtrlSetState($btnProd, $GUI_DISABLE)
			GUICtrlSetData ($inpProd, "prod.keys path")
			$prodkeys = '"' & @ScriptDir & "\prod.keys" & '"'
		EndIf
EndFunc

Func standardcheck()
;Enable menu changes when the standard forwarder checkbox is clicked
		If GUICtrlRead($chkStandard) = $GUI_CHECKED Then
			GUICtrlSetState($lblNroPath, $GUI_SHOW)
			GUICtrlSetState($inpNroPath, $GUI_SHOW)
			GUICtrlSetState($inpCorePath, $GUI_HIDE)
			GUICtrlSetState($lblCorePath, $GUI_HIDE)
			GUICtrlSetState($lblRomPath, $GUI_HIDE)
			GUICtrlSetState($inpRomPath, $GUI_HIDE)
			GUICtrlSetState ($chkRetroArch, $GUI_UNCHECKED)
		EndIf

EndFunc

Func retroarchcheck()
;Enable menu changes when the retroarch forwarder checkbox is clicked
		If GUICtrlRead($chkRetroArch) = $GUI_CHECKED Then
			GUICtrlSetState($lblNroPath, $GUI_HIDE)
			GUICtrlSetState($inpNroPath, $GUI_HIDE)
			GUICtrlSetState($inpCorePath, $GUI_SHOW)
			GUICtrlSetState($lblCorePath, $GUI_SHOW)
			GUICtrlSetState($lblRomPath, $GUI_SHOW)
			GUICtrlSetState($inpRomPath, $GUI_SHOW)
			GUICtrlSetState ($chkStandard, $GUI_UNCHECKED)
		EndIF

EndFunc


Func iconbrowse()
;Steup the browse for Icon dialog and copy resultant path
	$icon = FileOpenDialog ("Select your icon file, This needs to be a 256 x 256 jpg or jpeg", @ScriptDir, "Images (*.jpg;*.jpeg)", $FD_FILEMUSTEXIST)
	If @error Then
		GUICtrlSetData ($inpIcon, "Icon Path")
	Else
		GUICtrlSetData ($inpIcon, $icon)
	EndIf
EndFunc


Func logobrowse()
;Steup the browse for Icon dialog and copy resultant path
	$logo = FileOpenDialog ("Select your logo file, This needs to be a 160 x 40 png", @ScriptDir, "Images (*.png)", $FD_FILEMUSTEXIST)
	If @error Then
		GUICtrlSetData ($inpLogo, "Do not change for default")
	Else
		GUICtrlSetData ($inpLogo, $logo)
	EndIf
EndFunc

Func prodbrowse()
;Setup the browse for Prod.Keys dialog and copy resultant path
;'"' & @ScriptDir & "\prod.keys" & '"'
	$prodkeys = FileOpenDialog ("Select your Prod.keys file",@ScriptDir, "Prod.keys (*.keys)", $FD_FILEMUSTEXIST)
	if @error Then
		GUICtrlSetData ($inpProd, "prod.keys path")
		$prodkeys = '"' & @ScriptDir & "\prod.keys" & '"'
	Else
		GUICtrlSetData ($inpProd, $prodkeys)
	EndIf
EndFunc


Func errorcheck()

	;Check if prod.keys can be found
	$prodkeys = GUICtrlRead ($inpProd)
	If FileExists (@ScriptDir & "\prod.keys") = 0 And FileExists ($prodkeys) = 0 Then
		MsgBox (0, "Error", "No prod.keys found")
		$error = 1
		$prodkeys = '"' & @ScriptDir & "\prod.keys" & '"'
		Return
	Else
		$error = 0
	EndIf



	;Check The Application Name has changed
	If GUICtrlRead ($inpTitleName) = "Application Name" Then
		Msgbox(0,"Error","You Haven't Changed the Application Name")
		$error = 1
		Return
	Else
		$error = 0
	EndIf

	;Check the Author Name has changed
	If GUICtrlRead ($inpAuthor) = "Author Name" Then
		Msgbox(0,"Error","You Haven't Changed the Author Name")
		$error = 1
		Return
	Else
		$error = 0
	EndIf

	;Check if the Icon Path has changed
	If GUICtrlRead ($inpIcon) = "Icon Path" Then
		Msgbox(0,"Error","You Haven't Choosen an Icon")
		$error = 1
		Return
	Else
		$error = 0
	EndIf




EndFunc

Func imagemoves()
	;Move Images into the corect places
	FileCopy (GUICtrlRead ($inpIcon), @ScriptDir & "\control\icon_AmericanEnglish.dat",1)
	If GUICtrlRead ($inpLogo) = "Do not change for default" Then
		Return
	Else
		FileCopy (GUICtrlRead ($inpLogo), @ScriptDir & "\logo\NintendoLogo.png", 1)
	EndIf
EndFunc

Func pathwrites()
	If GUICtrlRead($chkStandard) = $GUI_CHECKED Then
		FileDelete (@ScriptDir & "\romfs\nextArgv")
		FileWrite (@ScriptDir & "\romfs\nextArgv", "sdmc:" & GUICtrlRead( $inpNroPath))
		FileDelete (@ScriptDir & "\romfs\nextNroPath")
		FileWrite (@ScriptDir & "\romfs\nextNroPath", "sdmc:" & GUICtrlRead( $inpNroPath))
	Else
		FileDelete (@ScriptDir & "\romfs\nextArgv")
		FileWrite (@ScriptDir & "\romfs\nextArgv", "sdmc:" & GUICtrlRead( $inpCorePath) & ' "' & "sdmc:" & GUICtrlRead ($inpRomPath) & '"')
		FileDelete (@ScriptDir & "\romfs\nextNroPath")
		FileWrite (@ScriptDir & "\romfs\nextNroPath", "sdmc:" & GUICtrlRead( $inpCorePath))
	EndIf
EndFunc


Func newbuild()


	;New build process try to do it all internally rather than create and run the batch file
		$titleid = GUICtrlRead ($inpTitleID)
		$titlename = GUICtrlRead ($inpTitleName)
		$titlepub = GUICtrlRead ($inpAuthor)

		ShellExecuteWait ($hacbrewpac, '--titleid "' & $titleid & '" ' & '--titlename "' & $titlename & '" ' & '--titlepublisher "' & $titlepub & '" --nspdir NSP -k ' & $prodkeys, @ScriptDir)

		FileMove (@ScriptDir & "\NSP\" & $titleid & ".nsp", @ScriptDir & "\NSP\" & $titlename & "_" & $titleid & ".nsp")
		ShellExecute ("Explorer.exe",@ScriptDir & "\NSP\",@ScriptDir & "\NSP\")


EndFunc

		;This Function has been replaced by newbuild
Func nspbuild()
;Build Command
		$titleid = GUICtrlRead ($inpTitleID)
		$titlename = GUICtrlRead ($inpTitleName)
		$titlepub = GUICtrlRead ($inpAuthor)
		$build = $hacbrewpac & " --titleid " & '"' & $titleid & '"' & " --titlename " & '"' & $titlename& '"' & " --titlepublisher " & '"' & $titlepub& '"' & " --nspdir NSP" & " -k " & $prodkeys


;Create the batch file
		FileDelete (@ScriptDir & "\GUI_Build.bat")
		FileWrite (@scriptDir & "\GUI_Build.bat", $build & @CRLF)
		FileWrite (@scriptDir & "\GUI_Build.bat", "exit")
		RunWait(@ComSpec & ' /k ' & '"' & @ScriptDir & '\GUI_Build.bat' & '"')
		FileMove (@ScriptDir & "\NSP\" & $titleid & ".nsp", @ScriptDir & "\NSP\" & $titlename & "_" & $titleid & ".nsp")
		ShellExecute ("Explorer.exe",@ScriptDir & "\NSP\",@ScriptDir & "\NSP\")

;Tidy Up

EndFunc


Func imgageconvert()
	;Sneek Peek - Try to convert images to the correct format should allow JPG, PNG, BMP, GIF, TIF to be resized and converted to JPG

	;example image resize    _GDIPlus_ImageResize ( $hImage, $iNewWidth, $iNewHeight [, $iInterpolationMode = $GDIP_INTERPOLATIONMODE_HIGHQUALITYBICUBIC] )
	;example image format conversion  _GDIPlus_ConvertImage($sIn, $sOut[, $iQuality = 90[, $iBGColor = 0x000000]])
	;https://www.autoitscript.com/forum/topic/148320-convert-image-formats-with-autoit-_gdi/


	_GDIPlus_Startup()

	 _GDIPlus_ImageResize ( $inpIcon, 256, 256)


	 ;_GDIPlus_ConvertImage($inpIcon, @ScriptDir & "\Temp.JPG", $iQuality = 100, $iBGColor = 0x000000)


	_GDIPlus_Shutdown()
EndFunc

Func tidy()
	;Reset everything to defaults

		;Delete icon_AmericanEnglish.dat
		FileDelete (@ScriptDir & "\control\icon_AmericanEnglish.dat")

		;Delete and create new empty nextArgv and nextNroPath files
		FileDelete (@ScriptDir & "\romfs\nextArgv")
		FileWrite (@ScriptDir & "\romfs\nextArgv","")
		FileDelete (@ScriptDir & "\romfs\nextNroPath")
		FileWrite (@ScriptDir & "\romfs\nextNroPath","")

		;Restore the NintendoLogo.png
		FileDelete (@ScriptDir & "\logo\NintendoLogo.png")
		FileMove (@ScriptDir & "\logo\NintendoLogo.bak", @ScriptDir & "\logo\NintendoLogo.png",1)

		;Delete the hacbrewpack_backup directory
		FileDelete (@ScriptDir & "\hacbrewpack_backup\*.*")
		DirRemove (@ScriptDir & "\hacbrewpack_backup\",1)

		;Delete the old GUI_Build.bat which is no longer needed
		FileDelete (@ScriptDir & "\GUI_Build.bat")


EndFunc